Imports System.Windows.Forms
Namespace NamSAccion
    Public Module clsAcciones
        Public Function Calculos(ByVal pOper As String, ByVal pV1 As Double, Optional ByVal pV2 As Double = 0) As String
            Select Case pOper
                Case "+"
                    Calculos = Str(pV1 + pV2)
                Case "-"
                    Calculos = Str(pV1 - pV2)
                Case "*"
                    Calculos = Str(pV1 * pV2)
                Case "/"
                    If pV2 = 0.0 Then
                        Calculos = "Error: divisin por cero"
                    Else
                        Calculos = Str(pV1 / pV2)
                    End If
                Case "X"
                    Calculos = Str(pV1 * pV1)
            End Select
        End Function

        Public Function Factorial(ByVal pDispl As Integer) As String
            On Error GoTo ErrDesb
            Dim i As Integer
            Dim r As Double = 1
            For i = 1 To pDispl
                r = r * i
            Next
            Factorial = Str(r)
            Exit Function
ErrDesb:
            Factorial = "El valor es demasiado alto"
        End Function

        Public Function Tecla(ByVal D As String, ByVal T As Integer) As String
            Select Case T
                Case Keys.NumPad0
                    'If D <> "0" Then
                    Tecla = Display(D, "0")
                    'End If
                Case Keys.NumPad1
                    Tecla = Display(D, "1")
                Case Keys.NumPad2
                    Tecla = Display(D, "2")
                Case Keys.NumPad3
                    Tecla = Display(D, "3")
                Case Keys.NumPad4
                    Tecla = Display(D, "4")
                Case Keys.NumPad5
                    Tecla = Display(D, "5")
                Case Keys.NumPad6
                    Tecla = Display(D, "6")
                Case Keys.NumPad7
                    Tecla = Display(D, "7")
                Case Keys.NumPad8
                    Tecla = Display(D, "8")
                Case Keys.NumPad9
                    Tecla = Display(D, "9")
                Case Keys.Decimal
                    If Punto(D) Then Tecla = D : Exit Function
                    Tecla = Display(D, ".")
                Case Keys.Back
                    Tecla = Display(D, "")
                Case Keys.Divide
                    If Operador <> "" Then
                        Tecla = Calculos(Operador, Monto1, CDbl(D))
                        If IsNumeric(Tecla) Then
                            Monto1 = CDbl(Tecla)
                            Operador = "/"
                            Borrar = True
                        Else
                            Monto1 = 0
                            Operador = ""
                            Borrar = True
                        End If
                    Else
                        Tecla = D
                        Monto1 = CDbl(D)
                        Operador = "/"
                        Borrar = True
                    End If
                Case Keys.Add
                    If Operador <> "" Then
                        Tecla = Calculos(Operador, Monto1, CDbl(D))
                        If IsNumeric(Tecla) Then
                            Monto1 = CDbl(Tecla)
                            Operador = "+"
                            Borrar = True
                        Else
                            Monto1 = 0
                            Operador = ""
                            Borrar = True
                        End If
                    Else
                        Tecla = D
                        Monto1 = CDbl(D)
                        Operador = "+"
                        Borrar = True
                    End If
                Case Keys.Multiply
                    If Operador <> "" Then
                        Tecla = Calculos(Operador, Monto1, CDbl(D))
                        If IsNumeric(Tecla) Then
                            Monto1 = CDbl(Tecla)
                            Operador = "*"
                            Borrar = True
                        Else
                            Monto1 = 0
                            Operador = ""
                            Borrar = True
                        End If
                    Else
                        Tecla = D
                        Monto1 = CDbl(D)
                        Operador = "*"
                        Borrar = True
                    End If
                Case Keys.Subtract
                    If Operador <> "" Then
                        Tecla = Calculos(Operador, Monto1, CDbl(D))
                        If IsNumeric(Tecla) Then
                            Monto1 = CDbl(Tecla)
                            Operador = "-"
                            Borrar = True
                        Else
                            Monto1 = 0
                            Operador = ""
                            Borrar = True
                        End If
                    Else
                        Tecla = D
                        Monto1 = CDbl(D)
                        Operador = "-"
                        Borrar = True
                    End If
                Case Keys.Delete
                    Tecla = "0"
                Case Keys.Escape
                    Tecla = "0"
                    Operador = ""
                    Borrar = False
                    Monto1 = 0
                Case Else
                    Tecla = D
            End Select
        End Function
    End Module

    Public Module ModCalc
        Public Operador As String
        Public Borrar As Boolean
        Public Monto1 As Double, Monto2 As Double
        Public Memoria As Double

        Public Function Display(ByVal pDispl As String, ByVal pChar As String) As String
            If pChar = "" Then
                If Len(pDispl) = 1 Then
                    Display = "0"
                Else
                    Display = Left(pDispl, Len(pDispl) - 1)
                End If
            Else
                If pDispl = "0" And Not pChar = "." Then pDispl = ""
                If Borrar Then
                    pDispl = ""
                    Borrar = False
                End If
                Display = pDispl & pChar
            End If
        End Function

        Public Function Punto(ByVal pDispl As String) As Boolean
            If InStr(pDispl, ".") > 0 Then
                Punto = True
            End If
        End Function
    End Module

End Namespace