﻿Public Class Form1
    Dim vector(1000) As Integer
    Dim Vector2(1000) As Integer
    Dim n = 1000
    Sub CargarTabla()
        Dim fila = 0
        Dim i, j As Integer
        ListView1.Items.Clear()
        For i = 0 To 1000
            ListView1.Items.Add(vector(i))
            For j = 1 To 9
                If i < 1000 Then
                    i += 1
                    ListView1.Items(fila).SubItems.Add(vector(i))
                End If
            Next
            fila += 1
        Next
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim Random As New Random()
        Dim i%
        For i = 0 To 1000
            Dim numero As Integer = Random.Next(1, 1001)
            vector(i) = numero
        Next
        vector.CopyTo(Vector2, 0)
        Array.Sort(Vector2)
        CargarTabla()
        btnBubbleSort.Enabled = True
        btnSelectionSort.Enabled = True
    End Sub

    Sub Probar()
        ListBox1.Items.Clear()
        Dim x As Boolean = True
        For i = 0 To 1000
            ListBox1.Items.Add(Vector2(i))
            If vector(i) <> Vector2(i) Then x = False
        Next
        If x = True Then MsgBox("El codigo está correcto")
        If x = False Then MsgBox("El codigo es incorrecto")
    End Sub
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
         Probar()
    End Sub

    Private Sub btnBubbleSort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBubbleSort.Click
        Dim temp = 0
        For i = 0 To n - 1
            For j = 0 To n - 1
                If (vector(j) > vector(j + 1)) Then
                    temp = vector(j)
                    vector(j) = vector(j + 1)
                    vector(j + 1) = temp
                End If
            Next
        Next
        CargarTabla()
        Button3.Enabled = True
    End Sub

    Private Sub btnSelectionSort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectionSort.Click
        Dim i, j, min, temp As Integer
        For i = 0 To n
            min = i
            For j = i + 1 To n
                If (vector(j) < vector(min)) Then min = j
            Next
            temp = vector(i)
            vector(i) = vector(min)
            vector(min) = temp
        Next
        CargarTabla()
        Button3.Enabled = True

    End Sub

    Private Sub btnBusquedaBinaria_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBusquedaBinaria.Click
        Dim encontrado = False
        Dim dato = Int(InputBox("digite el valor a buscar"))
        Dim inicio = 0, final = n, medio = 0
        While (inicio <= final)
            medio = Convert.ToInt32((inicio + final) / 2)
            If dato = vector(medio) Then
                encontrado = True
                Exit While
            ElseIf (dato > vector(medio)) Then
                inicio = medio + 1
            Else
                final = medio - 1
            End If
        End While
        If encontrado Then
            MsgBox("Se encontró el dato en la posicion " & medio)
        Else
            MsgBox("No Se encontró el dato")
        End If
    End Sub
End Class
