﻿Public Class frmArreglos
    Dim miVectorDeNombres() As String = {"Carlos", "Enrique", "Gabriela"}
    Const f = 3 'matriz de 3 filas
    Const c = 2 'matriz de columnas
    Dim miMatrizDeRegistros(f, c) As Object 'Matriz de 3 filas, 2 columnas

    Sub CargarListas()
        ListBox1.Items.Clear() 'borra los elementos en el listbox1
        ListBox2.Items.Clear() 'borra los elementos en el listbox2
        Dim indiceMatriz As Integer
        Dim registro$
        Array.Sort(miVectorDeNombres) 'Ordena el vector
        For Each indiceVector In miVectorDeNombres
            ListBox1.Items.Add(indiceVector)
        Next
        ListBox2.Items.Add("Nombre " & Space(8) & "Edad")
        For indiceMatriz = 0 To f
            registro = miMatrizDeRegistros(indiceMatriz, 0) & Space(4) & _
                       Convert.ToString(miMatrizDeRegistros(indiceMatriz, 1))
            ListBox2.Items.Add(registro)
        Next
    End Sub

    Private Sub btnCargar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCargar.Click
        CargarListas()
    End Sub

    Private Sub btnIncluir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnIncluir.Click
        Array.Clear(miVectorDeNombres, 0, 3) 'borra los elementos del vector.
        Array.Clear(miMatrizDeRegistros, 0, f) 'borra los elementos de la matriz.
        For i = 0 To 2
            miVectorDeNombres(i) = InputBox("Digite el nombre :")
            miMatrizDeRegistros(i, 0) = miVectorDeNombres(i)
            miMatrizDeRegistros(i, 1) = InputBox("Digite la edad para " & _
                                       miVectorDeNombres(i))
        Next
        CargarListas()
    End Sub
End Class
