﻿Public Class Form1
    Dim aLDispositivos As New ArrayList
    Dim Fila%
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        With ComboBox1.Items
            .Add("Hub")
            .Add("Switch")
            .Add("Bridge")
            .Add("Router")
        End With
        ComboBox1.SelectedIndex = 0
        Dim vector() As Integer = {8, 12, 16, 24, 48}
        ComboBox2.DataSource = vector
        ComboBox2.SelectedIndex = 0
    End Sub
    Private Sub btnAgregar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAgregar.Click
        aLDispositivos.Add(New Dispositivos(ComboBox1.Text, _
                 TextBox1.Text, _
                  Val(ComboBox2.Text), Val(TextBox2.Text)))
    End Sub
    Sub CargarLista()
        ListView1.Items.Clear()
        Fila = 0
        Dim aux As Dispositivos
        For Each aux In aLDispositivos
            ListView1.Items.Add(aux.pCategoria)
            ListView1.Items(Fila).SubItems.Add(Trim(aux.pMarca))
            ListView1.Items(Fila).SubItems.Add(aux.pNumPuertos)
            ListView1.Items(Fila).SubItems.Add(aux.pPrecio)
            Fila += 1
        Next
    End Sub
    Private Sub btnCargarLista_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCargarLista.Click
        CargarLista()
    End Sub
    Function Buscar() As Integer
        Dim posi = -1
        Dim i% = 0
        Dim aux As Dispositivos
        For Each aux In aLDispositivos
            If Trim(aux.pMarca) = Trim(TextBox1.Text) Then
                ComboBox1.Text = aux.pCategoria
                TextBox2.Text = aux.pPrecio
                ComboBox2.Text = aux.pNumPuertos
                posi = i
                Exit For
            End If
            i += 1
        Next
        Return posi
    End Function

    Private Sub btnBuscar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBuscar.Click
        Dim x = Buscar()
        If x < 0 Then
            MsgBox("No se encuentra la marca")
        Else
            MsgBox("Encontrado")
        End If
    End Sub
    Private Sub btnEliminar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEliminar.Click
        Dim x = Buscar()
        If x < 0 Then
            MsgBox("No se encuentra la marca")
        Else
            aLDispositivos.RemoveAt(x)
            CargarLista()
        End If
    End Sub
End Class
